% This source code is (c) Copyright 2008 by Lei Li.
% All rights preserved.
%
% Permission is granted to use it for non-profit purposes,
% including research and teaching. For-profit use requires
% the express consent of the author.

function [z V] = estimatePosterior(x, A, Gamma, C, Sigma, u0, V0, obs)
%estimate the hidden states from observed value
%obs: indicating whether x(i) is observed or missing

if (nargin < 8) 
    [u, V, P] = forward(x, A, Gamma, C, Sigma, u0, V0);
else
    [u, V, P] = forward(x, A, Gamma, C, Sigma, u0, V0, obs);
end
[z, V] = backward(u, V, P, A);