% This source code is (c) Copyright 2008 by Lei Li.
% All rights preserved.
%
% Permission is granted to use it for non-profit purposes,
% including research and teaching. For-profit use requires
% the express consent of the author.

function [pos, speed, acc] = estimateStitching(x, y, t, stigap)
%x first motion
%y second motion
%stitching from x to y
%stigap is the transition time for stitching, 
%ins is the number of intermediate points to insert
%ins = stigap - 1


%assume the time gap is 1
%t = 0.1;
if (nargin < 3) 
    t = 1;
end
if (nargin < 4) 
    stigap = 1;
end


ins = stigap - 1;

L = size(x,1);
N = size(y,1);
M = size(y,2);

x = [x; zeros(ins, M)];
obs = [ones(L, 1); zeros(ins, 1); ones(N, 1)];
  
[pos speed acc] = estimateState([x;y], t, obs);